### Bienvenido

+ ### Un npm para crear una collection

---
+ ## Que es una collection?

Una collection es un `Map()` pero "mejorado"

En si una collection es un map pero con mas metodos

Inicializacion
-
```
npm install collectors@latest
```
---
Como inicio creando un Collector?

---
+ **Primero, iniciamos requiriendo el npm y usando la clase**
---
```js
const Collection = require("collectors") //Requerimos el npm
const Collector = new Collection() //Iniciamos creando un nuevo collector
```
---
+ **Despues tendremos que usar los metodos para agregar datos al collector**
---
Cambios recientes
-
+ **`El metodo remove ya se puede usar para remover mas de un un key`**
  + **`Ejemplo`**
      ```js 
        Collector.remove(key1,key2,key3)
      ```
+ **`Se agrego el metodo position, que te da la posicion de un objeto`**
---
Metodos
---
+ [**`set`**](https://www.npmjs.com/package/collectors#set)
+ [**`remove`**](https://www.npmjs.com/package/collectors#remove)
+ [**`reset`**](https://www.npmjs.com/package/collectors#reset)
+ [**`get`**](https://www.npmjs.com/package/collectors#get)
+ [**`update`**](https://www.npmjs.com/package/collectors#update)
+ [**`map`**](https://www.npmjs.com/package/collectors#map)
+ [**`mapValues`**](https://www.npmjs.com/package/collectors#mapvalues)
+ [**`mapKeys`**](https://www.npmjs.com/package/collectors#mapkeys)
+ [**`every`**](https://www.npmjs.com/package/collectors#every)
+ [**`some`**](https://www.npmjs.com/package/collectors#some)
+ [**`clone`**](https://www.npmjs.com/package/collectors#clone)
+ [**`first`**](https://www.npmjs.com/package/collectors#first)
+ [**`last`**](https://www.npmjs.com/package/collectors#last)
+ [**`find`**](https://www.npmjs.com/package/collectors#find)
+ [**`filter`**](https://www.npmjs.com/package/collectors#filter)
+ [**`random`**](https://www.npmjs.com/package/collectors#random)
+ [**`has`**](https://www.npmjs.com/package/collectors#has)
+ [**`sort`**](https://www.npmjs.com/package/collectors#sort)
+ [**`forEach`**](https://www.npmjs.com/package/collectors#foreach)
+ [**`equals`**](https://www.npmjs.com/package/collectors#equals)
+ [**`concat`**](https://www.npmjs.com/package/collectors#concat)
+ [**`position`**](https://www.npmjs.com/package/collectors#position)
+ [**`toJson`**](https://www.npmjs.com/package/collectors#tojson)
---
### set
Estableces un dato en el Collector
```js
Collector.set("Key", ['Value one', 'Value two']) //return Collector
```
### remove
Eliminas un dato del Collector
```js
Collector.remove("Key") //return Collector
```
### reset
Reseteas el Collector
```js
Collector.reset() //return Collector
```
### get
Obtienes el valor de un key que este dentro del Collector
```js
Collector.get("Key") //return ['Value one', 'Value two']
```
### update
Actualizas el value de algun key
```js
Collector.update("Key",10)
```
### map
Mapeas los datos del Collector
```js
Collector.map(x => `Key: ${x.key} | Value: ${x.value}`) //return Array
```
### mapValues
Mapeas los valores del Collector
```js
Collector.mapValues(x => `Value: ${x}`) //return Array
```
### mapKeys
Mapeas los key del Collector
```js
Collector.mapKeys(x => `Key: ${x}`) //return Array
```
### every
Revisas si todos los datos del Collector cumplen con algo
```js
Collector.every(x => x.key === "Key") //return Boolean
```
### some
Revisas si algunos de los datos del Collector cumplen con algo
```js
Collector.some(x => x.key === "Key") //return Boolean
```
### clone
Clonas este Collector
```js
Collector.clone() //return new Collector
```
### first
El primer dato del Collector
```js
Collector.first() //return Object
```
### last
El ultimo dato del Collector
```js
Collector.last() //return Object
```
### find
Buscas algun dato del Collector
```js
Collector.find(x => x.key === "Key") //return Object
```
### filter
Te retorna los datos que cumplen el filtro que quieras
```js
Collector.filter(x => x.key.includes("K")) //return Array
```
### random
Te da un dato random del Collector
```js
Collector.random() //return Object
```
### has
Te dice si el dato existe en el Collector
```js
Collector.has("Key") //return Boolean
```
### sort
Ordenas los datos del Collector (solo funciona con numeros)
```js
let Collection = require("collectors")
let collector = new Collection().set('Key1',{dinero:10}).set('Key2',{dinero:5}).set('Key3',{dinero:9})
collector.sort((example1,example2) => example2.dinero - example1.dinero) //return new Collector pero ordenado
```
### forEach
Obtienes todos los datos del Collector
```js
Collector.forEach((x) => console.log(x)) //return Collector
```
### equals
Revisas si un Collector es el mismo que este collector (si tienen los mismos datos)
```js
Collector.equals(new Collection().set("key","10")) //return Boolean
```
### concat
Combinas Collectors para obtener uno solo
```js
Collector.concat(new Collection().set('key',"09")) //return new Collector
```
### position
Te da la posicion de un elemento (el index)
```js
Collector.position("Key") //return Number
```
### toJson
Te da todos los datos en un formato json o Object
```js
Collector.toJson() //return Object
```

[regresar al inicio](https://www.npmjs.com/package/collectors#bienvenido)